unit MainF;

interface

uses
  StdCtrls, Forms, Controls, Classes;

type
  TMainForm = class(TForm)
    ConvertButton : TButton;
    InputMemo     : TMemo;
    OutputMemo    : TMemo;

    procedure ConvertButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.ConvertButtonClick(Sender: TObject);
type
  TBooleanArray = array [0..7] of Boolean;

  function SplitByte(AByte : Byte) : TBooleanArray;
  var
    LIndex : LongInt;
  begin
    for LIndex := High(Result) downto Low(Result) do
    begin
      Result[LIndex] := ((AByte mod 2) <> 0);

      AByte := (AByte div 2);
    end;
  end;

var
  LIndexA : LongInt;
  LIndexB : LongInt;
  LMemory : TBooleanArray;
  LNext   : TBooleanArray;
  LNextLn : String;
begin
  OutputMemo.Lines.Clear;

  for LIndexA := Low(LMemory) to High(LMemory) do
    LMemory[LIndexA] := false;

  OutputMemo.Lines.Add('<<<<<<<<<<}');
  for LIndexA := 1 to Length(InputMemo.Text) do
  begin
    LNext   := SplitByte(Ord(InputMemo.Text[LIndexA]));
    LNextLn := '';
    for LIndexB := Low(LMemory) to High(LMemory) do
    begin
      if (LMemory[LIndexB] xor LNext[LIndexB]) then
      begin
        LMemory[LIndexB] := LNext[LIndexB];

        LNextLn := LNextLn + '}';
      end
      else
        LNextLn := LNextLn + '}<}';
    end;
    OutputMemo.Lines.Add(LNextLn);

    OutputMemo.Lines.Add('<<<<<<<<<<<}<}}<}}<}');
  end;
end;

end.
